<%-- $Id: edit_category.jsp 7604 2019-02-25 12:19:50Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg, Dominic Oyeniran

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Dominic
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.AnnotationTypeCategory"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Metadata"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.json.JsonUtil"
	import="net.sf.basedb.util.json.NameableConverter"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.clients.web.extensions.tabcontrol.TabAction"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Set"
	import="org.json.simple.JSONArray"
	import="org.json.simple.JSONObject"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.ANNOTATIONTYPECATEGORY;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	AnnotationTypeCategory annotationTypeCategory = null;

	
	if (itemId == 0)
	{
		//to create a new annotation category
		title = "Create annotation type category";
		cc.removeObject("item");
	}
	else
	{
		//if user click on edit, to edit annotationcategory
		annotationTypeCategory = AnnotationTypeCategory.getById(dc, itemId);
		cc.setObject("item", annotationTypeCategory);
		title = "Edit annotation type category-- " + HTML.encodeTags(annotationTypeCategory.getName());
		annotationTypeCategory.checkPermission(Permission.WRITE);
	}
	
	// ---- Query to retrieve annotationtype members for a category
	JSONObject jsonAnnotationTypes = new JSONObject();
	jsonAnnotationTypes.put("itemType", "ANNOTATIONTYPE");
	if (annotationTypeCategory != null)
	{
		ItemQuery<AnnotationType> query = annotationTypeCategory.getAnnotationTypes(null);
		query.include(Include.ALL);
		query.order(Orders.asc(Hql.property("name")));
		jsonAnnotationTypes.put("items", JsonUtil.toArray(query.iterate(dc), new NameableConverter<AnnotationType>()));
	}
	
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), annotationTypeCategory);
	ExtensionsInvoker<TabAction> invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="tabcontrol-2.js,linkitems-2.js,~categories.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>	
		
		<form action="index.jsp?ID=<%=ID%>" method="post" name="annotationTypeCategory">
		<input type="hidden" name="cmd" value="UpdateItem">

		<t:tabcontrol id="settings" 
			subclass="content dialogtabcontrol"
			position="bottom"
			remember="<%=annotationTypeCategory != null %>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Annotation type category" 
			helpid="annotationtypecategory.edit">
			<table class="fullform input100 smaller">
			<tr>
				<th>Name</th>
				<td><input class="text required auto-init" data-auto-init="<%=annotationTypeCategory == null ? "focus-select" : "focus" %>"
					type="text" name="name" 
					value="<%=HTML.encodeTags(annotationTypeCategory == null ? Values.getString(cc.getPropertyValue("name"), "New annotation type category") : annotationTypeCategory.getName())%>" 
					maxlength="<%=AnnotationTypeCategory.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="6" name="description" id="description"
						><%=HTML.encodeTags(annotationTypeCategory == null ? cc.getPropertyValue("description") : annotationTypeCategory.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			</table>
		</t:tab>
		
		<t:tab id="members" title="Annotation types" tooltip="Add/remove members of this category" 
			helpid="annotationtypecategory.edit.members">
			<table class="fullform input100">
			<tr class="dynamic">
				<th>Annotation types</th>
				<td>
					<div class="selectionlist">
						<table>
						<tr>
							<td>
								<select name="annotationTypes" id="annotationTypes" 
									class="auto-init" data-auto-init="link-container"
									data-initial-items="[<%=HTML.encodeTags(jsonAnnotationTypes.toJSONString()) %>]"
									size="14" multiple>
								</select>
							</td>
							<td style="vertical-align: top;">
								<base:buttongroup vertical="true">
									<base:button 
										id="btnAddAnnotationTypes"
										subclass="leftaligned auto-init"
										data-auto-init="add-link"
										data-list-id="annotationTypes"
										data-item-type="ANNOTATIONTYPE"
										title="Add&nbsp;annotation&nbsp;types&hellip;" 
										tooltip="Add annotation types to this category"
									/>
									<base:button 
										id="btnRemoveAnnotationTypes"
										subclass="leftaligned auto-init"
										data-auto-init="remove-link"
										data-list-id="annotationTypes"
										title="Remove" 
										tooltip="Remove the selected items from this category"
									/>
								</base:buttongroup>
							</td>
						</tr>
						</table>
					</div>
				</td>
			</tr>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
