<%-- $Id $
	------------------------------------------------------------------
	Copyright (C) 2010 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@page import="org.json.simple.JSONObject"%>
<%@page import="org.json.simple.JSONArray"%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.BioPlateType"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.clients.web.extensions.tabcontrol.TabAction"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.BIOPLATETYPE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	BioPlateType bioPlateType = null;
	BioWell.LockMode lockMode = BioWell.LockMode.UNLOCKED;
	boolean readCurrentSubtype = true;
	ItemSubtype currentSubtype = null;
	boolean readCurrentStorageType = true;
	ItemSubtype currentStorageType = null;
	
	ItemQuery<ItemSubtype> subtypesQuery = null;
	ItemQuery<ItemSubtype> storageTypeQuery = Base.getSubtypesQuery(Item.HARDWARE);
	
	if (itemId == 0)
	{
		title = "Create bioplate type";
		cc.removeObject("item");
		int lm = Values.getInt(cc.getPropertyValue("lockMode"));
		lockMode = BioWell.LockMode.fromValue(lm);
		subtypesQuery = Base.getSubtypesQuery(null);
		subtypesQuery.restrict(
				Restrictions.in(
					Hql.property("itemType"), 
					Expressions.integer(Item.SAMPLE.getValue()), Expressions.integer(Item.EXTRACT.getValue())
				));
	}
	else
	{
		bioPlateType = BioPlateType.getById(dc, itemId);
		bioPlateType.checkPermission(Permission.WRITE);
		lockMode = bioPlateType.getLockMode();
		cc.setObject("item", bioPlateType);
		title = "Edit bioplate type -- " + HTML.encodeTags(bioPlateType.getName());
		try
		{
			currentSubtype = bioPlateType.getItemSubtype();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentSubtype = false;
		}
		try
		{
			currentStorageType = bioPlateType.getStorageType();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentStorageType = false;
		}
		if (bioPlateType.getBioMaterialType() != null)
		{
			subtypesQuery = Base.getSubtypesQuery(bioPlateType.getBioMaterialType());
		}
	}
	
	JSONArray jsonSubtypes = new JSONArray();
	if (subtypesQuery != null)
	{
		for (ItemSubtype subtype : subtypesQuery.list(dc))
		{
			JSONObject jsonSubtype = new JSONObject();
			jsonSubtype.put("id", subtype.getId());
			jsonSubtype.put("name", subtype.getName());
			jsonSubtype.put("description", subtype.getDescription());
			jsonSubtype.put("bmType", subtype.getMainItemType().name());
			jsonSubtypes.add(jsonSubtype);
		}
	}
	
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), bioPlateType);
	ExtensionsInvoker<TabAction> invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="tabcontrol-2.js,~bioplatetypes.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="bioPlateType">
		<input type="hidden" name="cmd" value="UpdateItem">

		<div id="page-data" class="datacontainer"
			data-subtypes="<%=HTML.encodeTags(jsonSubtypes.toJSONString())%>"
			data-current-subtype="<%=currentSubtype == null ? 0 : currentSubtype.getId() %>"
			data-current-bm-type="<%=bioPlateType == null || bioPlateType.getBioMaterialType() == null ? "" : bioPlateType.getBioMaterialType().name() %>"
		></div>
	
		<t:tabcontrol id="settings" 
			subclass="content dialogtabcontrol"
			position="bottom"  remember="<%=bioPlateType != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Bioplate type" helpid="bioplatetype.edit">
			<table class="fullform input100">
			<tr>
				<th>Name</th>
				<td><input class="text required auto-init" data-auto-init="<%=bioPlateType == null ? "focus-select" : "focus" %>"
					type="text" name="name" 
					value="<%=HTML.encodeTags(bioPlateType == null ? Values.getString(cc.getPropertyValue("name"), "New bioplate type") : bioPlateType.getName())%>" 
					maxlength="<%=BioPlateType.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Biomaterial type</th>
				<%
				if (bioPlateType == null)
				{
					%>
						<td>
							<select name="bioMaterialType" id="bioMaterialType" class="required unchangeable">
							<option value="">- any -
							<option value="<%=Item.SAMPLE.name()%>">Sample
							<option value="<%=Item.EXTRACT.name()%>">Extract
							</select>
						</td>
					<%
				}
				else
				{
					%>
					<td><%=bioPlateType.getBioMaterialType() == null ? "- any -" : bioPlateType.getBioMaterialType()%></td>
					<%
				}
				%>
				<td></td>
			</tr>
			<%
			if (subtypesQuery != null)
			{
				%>
				<tr>
					<th>Biomaterial subtype</th>
					<td>
						<select name="subtype_id" id="subtype_id"
							<%=!readCurrentSubtype ? "disabled readonly class=\"disabled selectionlist\"" : "class=\"selectionlist\""%>>
						<%
						if (!readCurrentSubtype)
						{
							%>
							<option value="-1">- denied -
							<%
						}
						%>
						</select>
					</td>
					<td></td>
				</tr>
				<%
			}
			%>
			<tr>
				<th>Storage type</th>
				<td>
					<select name="storagetype_id" id="storeagetype_id"
						<%=!readCurrentStorageType ? "disabled readonly class=\"disabled selectionlist\"" : "class=\"selectionlist\""%>>
					<%
					if (!readCurrentStorageType)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						%>
						<option value="0">-none-
						<%
						int currentStorageTypeId = currentStorageType == null ? 0 : currentStorageType.getId();
						for (ItemSubtype storageType : storageTypeQuery.list(dc))
						{
							int id = storageType.getId();
							if (id != currentStorageTypeId && storageType.isRemoved()) continue;
							%>
							<option value="<%=id == currentStorageTypeId && bioPlateType != null ? -id : id%>" 
								<%=id == currentStorageTypeId ? "selected" : ""%>
								title="<%=HTML.encodeTags(storageType.getDescription()) %>"
								><%=HTML.encodeTags(storageType.getName())%>
							<%
						}
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Well lock mode</th>
				<td>
					<select name="lockMode" class="selectionlist">
					<%
					for (BioWell.LockMode lm : BioWell.LockMode.values())
					{
						String selected = lm == lockMode ? "selected" : "";
						%>
						<option value="<%=lm.name()%>" <%=selected%>><%=lm%>
						<%
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="6" name="description" id="description"
						><%=HTML.encodeTags(bioPlateType == null ? cc.getPropertyValue("description") : bioPlateType.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>

		<div class="legend">
			<base:icon image="required.png" />= required information
			<%if (bioPlateType == null) {%><br>
				<base:icon image="unchangeable.png" />= can't be changed later
			<%}%>
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
