<%-- $Id$
	------------------------------------------------------------------
	Copyright (C) 2015 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.AnnotatedItem"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.AnnotationUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="org.json.simple.JSONObject"
	import="org.json.simple.JSONArray"
	import="java.util.Collections"
	import="java.util.List"
	import="java.util.Set"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final String subContext = Values.getString(request.getParameter("subcontext"), "");
final ItemContext cc = sc.getCurrentContext(itemType, subContext);

final DbControl dc = sc.newDbControl();
try
{
	Set<AnnotatedItem> items = cc.getObject("AnnotatedItems");
	Set<AnnotationType> annotationTypes = cc.getObject("AnnotationTypes");
	cc.removeObject("AnnotationTypes");
	JSONArray jsonAnnotationTypes = new JSONArray();
	if (annotationTypes != null)
	{
		for (AnnotationType at : annotationTypes)
		{
			JSONObject jsonAnnotationType = AnnotationUtil.loadJsonForBatchInherit(dc, AnnotationType.getById(dc, at.getId()));
			jsonAnnotationTypes.add(jsonAnnotationType);
		}
	}
	%>
	<base:page type="popup" title="Batch inherit annotations">
	<base:head scripts="table.js,~batch_inherit.js" styles="table.css,toolbar.css">
	<style>
	#selectedAnnotationTypes select
	{
		width: calc(100% - 10px);
	}
	</style>
	</base:head>
	<base:body>
		<h1>Batch inherit annotations to <%=items.size()%> items <base:help helpid="annotations.batch_inherit" /></h1>
			
		<div id="page-data" class="datacontainer"
			data-annotation-types="<%=HTML.encodeTags(jsonAnnotationTypes.toJSONString())%>"
		></div>
			
		<div class="content">
			<tbl:table id="annotations" subclass="fulltable" stickyheaders="<%=null%>" action="index.jsp">
				<tbl:hidden name="item_type" value="<%=itemType.name() %>"/>
				<tbl:hidden name="subcontext" value="<%=subContext %>"/>
				
				<tbl:columndef id="annotationType" title="Annotation type" />
				<tbl:columndef id="action" title="Action" style="min-width: 10em;"/>
				<tbl:columndef id="from" title="Parent item type" style="min-width: 10em;" />
				<tbl:columndef id="options" title="Options" />
				<div class="panelgroup bg-filled-50 bottomborder" style="height: 1.9em;">
					<tbl:toolbar style="height: 100%;">
						<tbl:button 
							id="btnSelectAnnotationTypes" 
							title="Select annotation types&hellip;" 
							image="add.png" 
							tooltip="Select annotations types that should be inherited"	
						/>
					</tbl:toolbar>
				</div>
				<tbl:data style="top: 1.9em;">
					<tbl:headers>
						<tbl:headerrow>
							<tbl:columnheaders />
						</tbl:headerrow>
					</tbl:headers>
					<tbl:rows id="selectedAnnotationTypes">
						
						<tbl:panel subclass="bg-filled-50" id="none-selected">
							<div class="messagecontainer note">
							No annotation types has been selected yet.
							</div>
						</tbl:panel>
					</tbl:rows>
				</tbl:data>
			</tbl:table>
		</div>			
		
		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Ok" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>