<%-- $Id: save_preset.jsp 6607 2014-11-19 14:52:20Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2020 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.SyncFilter.SourceItemTransform"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.listable.SourceItemTransformerFactory"
	import="net.sf.basedb.util.listable.ListableUtil"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final Item itemType = Item.valueOf(request.getParameter("item_type"));

SourceItemTransformerFactory factory = ListableUtil.getTransformerFactory(itemType);
List<Item> allowedParentItems = factory.getSupportedSourceItems(SourceItemTransform.PARENT_TO_CHILD);
List<Item> allowedChildItems = factory.getSupportedSourceItems(SourceItemTransform.CHILD_TO_PARENT);
%>
<base:page type="popup" title="Add parent or child item column">
<base:head scripts="~add_relateditem_column.js" />
<base:body>
	<h1>Add parent or child item column <base:help helpid="columns.configure.add_relateditem_column" /></h1>

	<form name="relatedItems" method="post">
	<input type="hidden" name="ID" value="<%=ID%>">
	<input type="hidden" name="item_type" value="<%=itemType.name()%>">
	
	<div class="content">
		<table class="fullform input100 smaller bottomborder">
		<tr>
			<th>Item type</th>
			<td>
				<select name="targetItemType" id="targetItemType" style="min-width: 15em;">
					<option value="">- select -
					<%
					for (Item parentType : allowedParentItems)
					{
						%>
						<option value="<%=parentType.name()%>" data-direction="PARENT">Parent: <%=parentType.toString()%>
						<%
					}
					for (Item childType : allowedChildItems)
					{
						%>
						<option value="<%=childType.name()%>" data-direction="CHILD">Child: <%=childType.toString()%>
						<%
					}
					%>
				</select>
			</td>
		</tr>
		<tr>
			<th>Subtype</th>
			<td>
				<select name="subtype" id="subtype" style="min-width: 15em;">
					<option value="">- select -
				</select>
				<label><input type="checkbox" id="showAllAnnotationTypes" name="showAllAnnotationTypes">Show annotation types for all subtypes</label>
			</td>
		</tr>
		<tr class="dynamic">
			<th>Column</th>
			<td>
				<select name="column" id="column" style="min-width: 25em; height: calc(100% - 4em);" multiple></select>
				<div id="added-column-msg" class="messagecontainer note" style="display:none; margin: 0.5em 0;"></div>
			</td>
		</tr>
		</table>
	</div>
	</form>

	<base:buttongroup subclass="dialogbuttons">
		<base:button id="btnAdd" title="Add" />
		<base:button id="close" title="Close" />
	</base:buttongroup>

</base:body>
</base:page>


